{****************************************************************************

                   Copyright (c) 1993,96 by Florian Klaempfl

 ****************************************************************************}


{
  this unit does optimizations on the assembler code

  + feature added
  - removed
  * bug fixed or changed

  History (started with version 0.9.0):
       5th november 1996:
         * adapted to 0.9.0
}

unit aopt386;

  interface

    uses
       cobjects,globals,aasm,symtable,strings
{$ifdef i386}
       ,i386
       ,cgi386
{$else}
{$endif}
       ;

    { does simple optimizations like jumps and remove pop/pushes }
    procedure simpljumpopt(var asml : taasmoutput);

  implementation

    procedure simpljumpopt(var asml : taasmoutput);

      var
         p,hp1,hp2 : pai386;
         jump : boolean;

      begin
{$ifdef dummy}
         p:=pai386(asml.first);
         while assigned(p) do
           begin
              jump:=false;
              case p^.instruc of
                 A_JE,
                 A_JNE,
                 A_JL,
                 A_JG,
                 A_JLE,
                 JGE,
                 JNZ,
                 JNO,
                 JZ,
                 JS,
                 JNS,
                 JO,
                 JC,
                 JNC,
                 JA,
                 JAE,
                 JB,
                 JBE
                  : begin
                         jump:=true;
                         if (assigned(p^.next)) and
                            (p^.next^.instruc=JMP) and
                            (assigned(p^.next^.next)) and
                            (p^.next^.next^.instruc=A_LABEL) and
                            (p^.next^.next^.l=p^.l) then
                           begin
                              case p^.instruc of
                                 JE : p^.instruc:=JNE;
                                 JNE : p^.instruc:=JE;
                                 JL : p^.instruc:=JGE;
                                 JG : p^.instruc:=JLE;
                                 JLE : p^.instruc:=JG;
                                 JGE : p^.instruc:=JL;
                                 JNZ : p^.instruc:=JZ;
                                 JNO : p^.instruc:=JO;
                                 JZ : p^.instruc:=JNZ;
                                 JS : p^.instruc:=JNS;
                                 JNS : p^.instruc:=JS;
                                 JO : p^.instruc:=JNO;
                                 JC : p^.instruc:=JNC;
                                 JNC : p^.instruc:=JC;
                                 JA : p^.instruc:=JBE;
                                 JAE : p^.instruc:=JB;
                                 JB : p^.instruc:=JAE;
                                 JBE : p^.instruc:=JA;
                               end;
                              p^.next^.instruc:=A_NONE;
                              p^.l:=p^.next^.l;
                           end;
                      end;
                 JMP : begin
                          jump:=true;
                      end;
                 POP : begin
                           if (assigned(p^.next)) and
                              (p^.next^.instruc=PUSH) and
                              (strcomp(p^.t,p^.next^.t)=0) then
                             begin
                                p^.instruc:=A_NONE;
                                p^.next^.instruc:=A_NONE;
                             end;
                        end;
              end;
            if jump then
              begin
                 if (assigned(p^.next)) and
                    (p^.next^.instruc=A_LABEL) and
                    (p^.next^.l=p^.l) then
                       p^.instruc:=A_NONE;
             end;
         p:=p^.next;
      end;
{$endif}
    end;

end.
