{****************************************************************************

                    Copyright (c) 1995,96 by Florian Klaempfl

 ****************************************************************************}

{
  this unit implements an asmlistitem class for the i386+

  History:
      30th september 1996:
         + unit started
      15th october 1996:
         + tai386 added
         + some code from asmgen moved to this unit
      26th november 1996:
         + tai386_labeled
}
unit i386;

  interface

    uses
       strings,systems,cobjects,aasm;

    type
       tasmop = (A_MOV,A_MOVZX,A_MOVSX,A_LABEL,A_ADD,
                 A_CALL,A_IDIV,A_IMUL,A_JMP,A_LEA,A_MUL,A_NEG,A_NOT,
                 A_POP,A_POPAD,A_PUSH,A_PUSHAD,A_RET,A_SUB,A_XCHG,A_XOR,
                 A_FILD,A_CMP,A_JZ,A_INC,A_DEC,A_SETE,A_SETNE,A_SETL,
                 A_SETG,A_SETLE,A_SETGE,A_JE,A_JNE,A_JL,A_JG,A_JLE,A_JGE,
                 A_OR,A_FLD,A_FADD,A_FMUL,A_FSUB,A_FDIV,A_FCHS,A_FLD1,
                 A_FIDIV,A_CLTD,A_JNZ,A_FSTP,A_AND,A_JNO,A_NOTH,A_NONE,
                 A_ENTER,A_LEAVE,A_CLD,A_MOVS,A_REP,A_SHL,A_SHR,A_BOUND,
                 A_JNS,A_JS,A_JO,A_SAR,A_TEST,
                 A_FCOM,A_FCOMP,A_FCOMPP,A_FXCH,A_FADDP,A_FMULP,A_FSUBP,A_FDIVP,
                 A_FNSTS,A_SAHF,A_FDIVRP,A_FSUBRP,A_SETC,A_SETNC,A_JC,A_JNC,
                 A_JA,A_JAE,A_JB,A_JBE,A_SETA,A_SETAE,A_SETB,A_SETBE,
                 A_AAA,A_AAD,A_AAM,A_AAS,A_CBW,A_CDQ,A_CLC,A_CLI,
                 A_CLTS,A_CMC,A_CWD,A_CWDE,A_DAA,A_DAS,A_HLT,A_IRET,A_LAHF,
                 A_LODS,A_LOCK,A_NOP,A_PUSHA,A_PUSHF,A_PUSHFD,
                 A_STC,A_STD,A_STI,A_STOS,A_WAIT,A_XLAT,A_XLATB,A_MOVSB,
                 A_MOVSBL,A_MOVSBW,A_MOVSWL,A_MOVZB,A_MOVZWL,A_POPA,A_IN,
                 A_OUT,A_LDS,A_LCS,A_LES,A_LFS,A_LGS,A_LSS,A_POPF,A_SBB,A_ADC,
                 A_DIV,A_ROR,A_ROL,A_RCL,A_RCR,A_SAL,A_SHLD,A_SHRD,
                 A_LCALL,A_LJMP,A_LRET,A_JNAE,A_JNB,A_JNA,A_JNBE,A_JP,A_JNP,
                 A_JPE,A_JPO,A_JNGE,A_JNG,A_JNL,A_JNLE,A_JCXZ,A_JECXZ,

                 A_LOOP,A_CMPS,A_INS,A_OUTS,A_SCAS,A_BSF,A_BSR,A_BT,A_BTC,A_BTR,A_BTS,A_INT,
                 A_INT3,A_INTO,A_BOUNDL,A_BOUNDW,
                 A_LOOPZ,A_LOOPE,A_LOOPNZ,A_LOOPNE,A_SETO,A_SETNO,A_SETNAE,A_SETNB,
                 A_SETZ,A_SETNZ,A_SETNA,A_SETNBE,A_SETS,A_SETNS,A_SETP,A_SETPE,A_SETNP,
                 A_SETPO,A_SETNGE,A_SETNL,A_SETNG,A_SETNLE,A_ARPL,A_LAR,A_LGDT,A_LIDT,
                 A_LLDT,A_LMSW,A_LSL,A_LTR,A_SGDT,A_SIDT,A_SLDT,A_SMSW,A_STR,A_VERR,A_VERW,
                 A_FABS,A_FBLD,A_FBSTP,A_FCLEX,A_FNCLEX,
                 A_FCOS,A_FDECSTP,A_FDISI,A_FNDISI,
                 A_FDIVR,A_FENI,A_FNENI,A_FFREE,A_FIADD,A_FICOM,A_FICOMP,
                 A_FIDIVR,A_FIMUL,A_FINCSTP,A_FINIT,A_FNINIT,A_FIST,A_FISTP,A_FISUB,
                 A_FISUBR,A_FLDCW,A_FLDENV,A_FLDLG2,A_FLDLN2,A_FLDL2E,
                 A_FLDL2T,A_FLDPI,A_FLDS,A_FLDZ,A_FNOP,A_FPATAN,
                 A_FPREM,A_FPREM1,A_FPTAN,A_FRNDINT,A_FRSTOR,A_FSAVE,A_FNSAVE,
                 A_FSCALE,A_FSETPM,A_FSIN,A_FSINCOS,A_FSQRT,A_FST,A_FSTCW,A_FNSTCW,
                 A_FSTENV,A_FNSTENV,A_FSTSW,A_FNSTSW,A_FTST,A_FUCOM,A_FUCOMP,
                 A_FUCOMPP,A_FWAIT,A_FXAM,A_FXTRACT,A_FYL2X,A_FYL2XP1,A_F2XM1,
                 A_FILDQ,A_FILDS,A_FILDL,A_FLDL,A_FLDT,A_FISTQ,A_FISTS,A_FISTL,A_FSTL,A_FSTS,
                 A_FSTPS,A_FISTPL,A_FSTPL,A_FISTPS,A_FISTPQ,A_FSTPT,
                 A_FCOMPS,A_FICOMPL,A_FCOMPL,A_FICOMPS,
                 A_FCOMS,A_FICOML,A_FCOML,A_FICOMS,A_FIADDL,A_FADDL,A_FIADDS,
                 A_FISUBL,A_FSUBL,A_FISUBS,A_FSUBS,A_FSUBR,A_FSUBRS,A_FISUBRL,
                 A_FSUBRL,A_FISUBRS,A_FMULS,A_FIMULL,A_FMULL,A_FIMULS,A_FDIVS,A_FIDIVL,
                 A_FDIVL,A_FIDIVS,A_FDIVRS,A_FIDIVRL,A_FDIVRL,A_FIDIVRS,
                 A_REPE,A_REPNE,A_FADDS);

       { enumeration for registers, don't change this }
       { it's used by the register size converstaions }
       tregister = (R_NO,R_EAX,R_ECX,R_EDX,R_EBX,R_ESP,R_EBP,R_ESI,R_EDI,
                    R_AX,R_CX,R_DX,R_BX,R_SP,R_BP,R_SI,R_DI,
                    R_AL,R_CL,R_DL,R_BL,
                    { for an easier assembler generation }
                    R_DEFAULT_SEG,R_CS,R_DS,R_ES,R_FS,R_GS,R_SS);

       topsize = (S_NO,S_B,S_W,S_L,S_BW,S_BL,S_WL);

       plocation = ^tlocation;

       { information about the location of an operand }
       { LOC_FPU_STACK   FPU stack }
       { LOC_REGISTER    in a processor register }
       { LOC_MEM         in the memory }
       { LOC_REFERENCE   like LOC_MEM, but lvalue }
       { LOC_JUMP        nur bool'sche Resultate, Sprung zu false- oder }
       {                 truelabel }
       { LOC_FLAGS       nur bool'sche Rsultate, Flags sind gesetzt }
       { LOC_CREGISTER   register which shouldn't be modified }
       { LOC_INVALID     added for tracking problems}

       tloc = (LOC_FPUSTACK,LOC_REGISTER,LOC_MEM,LOC_REFERENCE,LOC_JUMP,
               LOC_FLAGS,LOC_CREGISTER,LOC_INVALID);

       tresflags = (F_E,F_NE,F_G,F_L,F_GE,F_LE,F_C,F_NC,
                    F_A,F_AE,F_B,F_BE);

       preference = ^treference;

       treference = record
          offset : longint;
          symbol : pstring;
          base,index,segment : tregister;
          { a constant is also a treference, this makes the code generator }
          { easier                                                         }
          isintvalue : boolean;
          scalefactor : byte;
       end;

       tlocation = record
          case loc : tloc of
             LOC_REGISTER : (register : tregister);
             LOC_MEM,LOC_REFERENCE : (reference : treference);
             LOC_FPUSTACK : ();
             LOC_JUMP : ();
             LOC_FLAGS : (resflags : tresflags);
             LOC_INVALID : ();
       end;

       pcsymbol = ^tcsymbol;

       tcsymbol = record
          symbol : pchar;
          offset : longint;
       end;

    const
       { arrays for boolean location conversations }
       flag_2_jmp : array[F_E..F_BE] of tasmop =
          (A_JE,A_JNE,A_JG,A_JL,A_JGE,A_JLE,A_JC,A_JNC,
           A_JA,A_JAE,A_JB,A_JBE);

       flag_2_set : array[F_E..F_BE] of tasmop =        { v-- the GAS didn't know setc }
          (A_SETE,A_SETNE,A_SETG,A_SETL,A_SETGE,A_SETLE,A_SETB,A_SETAE,
           A_SETA,A_SETAE,A_SETB,A_SETBE);

       { operand types }
       top_none = 0;
       top_reg = 1;
       top_ref = 2;

       { a constant can be also written as treference }
       top_const = 3;

       { this is for calls }
       top_symbol = 4;

    type
       pai386 = ^tai386;

       tai386 = object(tai)
          { this isn't a proper style, but not very memory expensive }
          op1,op2,op3 : pointer;
          operator : tasmop;
          op1t,op2t,op3t : byte;
          size : topsize;
          constructor op_none(op : tasmop;_size : topsize);

          constructor op_reg(op : tasmop;_size : topsize;_op1 : tregister);
          constructor op_const(op : tasmop;_size : topsize;_op1 : longint);
          constructor op_ref(op : tasmop;_size : topsize;_op1 : preference);

          constructor op_reg_reg(op : tasmop;_size : topsize;_op1,_op2 : tregister);
          constructor op_reg_ref(op : tasmop;_size : topsize;_op1 : tregister;_op2 : preference);

          constructor op_const_reg(op : tasmop;_size : topsize;_op1 : longint;_op2 : tregister);
          { this combination is needed by ENTER }
          constructor op_const_const(op : tasmop;_size : topsize;_op1,_op2 : longint);
          constructor op_const_ref(op : tasmop;_size : topsize;_op1 : longint;_op2 : preference);

          constructor op_ref_reg(op : tasmop;_size : topsize;_op1 : preference;_op2 : tregister);
          { this is only allowed if _op1 is an int value (_op1^.isintvalue=true) }
          constructor op_ref_ref(op : tasmop;_size : topsize;_op1,_op2 : preference);

          { this is for CALL etc.                           }
          { symbol is replaced by the address of symbol     }
          { so op_symbol(A_PUSH,S_L,strnew('P')); generates }
          { an instruction which pushes the address of P    }
          { to the stack                                    }
          constructor op_csymbol(op : tasmop;_size : topsize;_op1 : pcsymbol);
          constructor op_csymbol_reg(op : tasmop;_size : topsize;_op1 : pcsymbol;_op2 : tregister);
          constructor op_csymbol_ref(op : tasmop;_size : topsize;_op1 : pcsymbol;_op2 : preference);
       end;

       pai_labeled386 = ^tai_labeled386;

       tai_labeled386 = object(tai)
          operator : tasmop;
          lab : tlabel;
          constructor init(op : tasmop;l : tlabel);
       end;

    const
       maxvarregs = 4;

       varregs : array[1..maxvarregs] of tregister =
         (R_EBX,R_EDX,R_ECX,R_EAX);

       nextlabelnr : longint = 1;

    { the following functions allow to convert registers }
    { for example reg8toreg32(R_AL) returns R_EAX        }
    { for example reg16toreg32(R_AL) gives an undefined  }
    { result                                             }
    { these functions expects that the turn of           }
    { tregister isn't changed                            }
    function reg8toreg16(reg : tregister) : tregister;
    function reg8toreg32(reg : tregister) : tregister;
    function reg16toreg8(reg : tregister) : tregister;
    function reg32toreg8(reg : tregister) : tregister;
    function reg32toreg16(reg : tregister) : tregister;
    function reg16toreg32(reg : tregister) : tregister;

    { resets all values of ref to defaults }
    procedure reset_reference(var ref : treference);

    { same as reset_reference, but symbol is disposed }
    { use this only for already used references       }
    procedure clear_reference(var ref : treference);

    { make l as a new label }
    procedure getlabel(var l : tlabel);

    function newreference(const r : treference) : preference;

    function reg2str(r : tregister) : string;

    { generates an help record for constants }
    function newcsymbol(const s : string;l : longint) : pcsymbol;

  implementation

    function reg2str(r : tregister) : string;

      const
         a : array[R_NO..R_BL] of string[3] =
          ('','EAX','ECX','EDX','EBX','ESP','EBP','ESI','EDI',
           'AX','CX','DX','BX','SP','BP','DI','DI',
           'AL','CL','DL','BL');

      begin
         reg2str:=a[r];
      end;

    function newreference(const r : treference) : preference;

      var
         p : preference;

      begin
         new(p);
         p^:=r;
         if assigned(r.symbol) then
           p^.symbol:=stringdup(r.symbol^);
         newreference:=p;
      end;

    function reg8toreg16(reg : tregister) : tregister;

      begin
         reg8toreg16:=reg32toreg16(reg8toreg32(reg));
      end;

    function reg16toreg8(reg : tregister) : tregister;

      begin
         reg16toreg8:=reg32toreg8(reg16toreg32(reg));
      end;

    function reg16toreg32(reg : tregister) : tregister;

      begin
         reg16toreg32:=tregister(byte(reg)-byte(R_EDI));
      end;

    function reg32toreg16(reg : tregister) : tregister;

      begin
         reg32toreg16:=tregister(byte(reg)+byte(R_EDI));
      end;

    function reg32toreg8(reg : tregister) : tregister;

      begin
         reg32toreg8:=tregister(byte(reg)+byte(R_DI));
      end;

    function reg8toreg32(reg : tregister) : tregister;

      begin
         reg8toreg32:=tregister(byte(reg)-byte(R_DI));
      end;

    procedure reset_reference(var ref : treference);

      begin
         with ref do
           begin
              index:=R_NO;
              base:=R_NO;
              segment:=R_DEFAULT_SEG;
              offset:=0;
              scalefactor:=1;
              isintvalue:=false;
              symbol:=nil;
           end;
      end;

    procedure clear_reference(var ref : treference);

      begin
         stringdispose(ref.symbol);
         reset_reference(ref);
      end;

    procedure getlabel(var l : tlabel);

      begin
         l:=nextlabelnr;
         inc(nextlabelnr);
      end;

    function newcsymbol(const s : string;l : longint) : pcsymbol;

      var
         p : pcsymbol;

      begin
         new(p);
         p^.symbol:=strpnew(s);
         p^.offset:=l;
         newcsymbol:=p;
      end;

{****************************************************************************
                             TAI386
 ****************************************************************************}

    constructor tai386.op_none(op : tasmop;_size : topsize);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_none;
         op2t:=top_none;
         op3t:=top_none;
         size:=_size;

         { the following isn't required ! }
         op1:=nil;
         op2:=nil;
         op3:=nil;
      end;

    constructor tai386.op_reg(op : tasmop;_size : topsize;_op1 : tregister);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_reg;
         op2t:=top_none;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);

         op2:=nil;
         op3:=nil;
      end;

    constructor tai386.op_const(op : tasmop;_size : topsize;_op1 : longint);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_const;
         op2t:=top_none;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);

         op2:=nil;
         op3:=nil;
      end;

    constructor tai386.op_ref(op : tasmop;_size : topsize;_op1 : preference);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_ref;
         op2t:=top_none;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);

         op2:=nil;
         op3:=nil;
      end;

    constructor tai386.op_reg_reg(op : tasmop;_size : topsize;_op1,_op2 : tregister);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_reg;
         op2t:=top_reg;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_reg_ref(op : tasmop;_size : topsize;_op1 : tregister;_op2 : preference);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_reg;
         op2t:=top_ref;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_const_reg(op : tasmop;_size : topsize;_op1 : longint;_op2 : tregister);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_const;
         op2t:=top_reg;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_const_const(op : tasmop;_size : topsize;_op1,_op2 : longint);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_const;
         op2t:=top_const;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_const_ref(op : tasmop;_size : topsize;_op1 : longint;_op2 : preference);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_const;
         op2t:=top_ref;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_ref_reg(op : tasmop;_size : topsize;_op1 : preference;_op2 : tregister);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_ref;
         op2t:=top_reg;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_ref_ref(op : tasmop;_size : topsize;_op1,_op2 : preference);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_ref;
         op2t:=top_ref;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_csymbol(op : tasmop;_size : topsize;_op1 : pcsymbol);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_symbol;
         op2t:=top_none;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);

         op2:=nil;
         op3:=nil;
      end;

    constructor tai386.op_csymbol_reg(op : tasmop;_size : topsize;_op1 : pcsymbol;_op2 : tregister);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_symbol;
         op2t:=top_reg;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

    constructor tai386.op_csymbol_ref(op : tasmop;_size : topsize;_op1 : pcsymbol;_op2 : preference);

      begin
         typ:=ait_instruction;
         operator:=op;
         op1t:=top_symbol;
         op2t:=top_ref;
         op3t:=top_none;
         size:=_size;
         op1:=pointer(_op1);
         op2:=pointer(_op2);

         op3:=nil;
      end;

{****************************************************************************
                             TAI_LABELED386
 ****************************************************************************}

    constructor tai_labeled386.init(op : tasmop;l : tlabel);

      begin
         typ:=ait_labeled_instruction;
         operator:=op;
         lab:=l;
      end;

end.
